> ## Documentation Index
> Fetch the complete documentation index at: https://docs.rated.network/llms.txt
> Use this file to discover all available pages before exploring further.

# Get validator block insights

> This endpoint returns information about the composition of blocks produced by a validator. Use this endpoint to retrieve historical block insights for a specific validator.

You can query this endpoint by using the `vote_account` address of a validator as the `validator_id`. The granularity of results can either be daily or around 20 minute intervals (3,000 slots).

<Note>
  Earliest daily data available is from March 1, 2025.
</Note>


## OpenAPI

````yaml get /v1/solana/validators/{validator_id}/blockInsights
openapi: 3.1.0
info:
  title: Rated API
  description: >

    Welcome to Rated API Swagger doc for developers! This doc outlines the Rated
    API functionality and API architecture.


    V0: It is separated into seven categories:


    -   **Validators**: Endpoints to query into individual validator indices or
    aggregations of validator indices.

    -   **Operators**: Endpoints to query into pre-materialized operator
    groupings.

    -   **Network**: Endpoints to query into network aggregate stats.

    -   **Slashings**: Endpoints to query into network aggregate stats.

    -   **Withdrawals (beta)**: Endpoints to query into when a withdrawal is
    expected to land.

    -   **Self Report (beta)**: Endpoint to query into all slashed validators
    and individual slashed validator indices


    V1: It is separated into six categories:

    -   **Overview**: Endpoints encapsulating the current status of operators,
    pools and validators.

    -   **Performance**: Endpoints that dive into performance and effectiveness
    metrics on execution and consensus layer for operators, pools and
    validators.

    -   **Rewards**: Endpoints that dive into relevant metrics around rewards
    and penalties for operators, pools and validators.

    -   **Private Sets**: Endpoints that aggregate custom group of validators
    privately for performance and reward drill downs.

    -   **Metadata**: Endpoints that provide metadata about mappings, slashings
    and APRs for validators, pools and operators.

    -   **Network**: Endpoints that provide network level metrics about
    performance, rewards, and distributions.


    [Terms of Use](https://docs.rated.network/legal/terms/api-terms-of-service)


    [API
    Reference](https://docs.rated.network/rated-api/api-reference/introduction)
  version: '1.0'
servers: []
security: []
paths:
  /v1/solana/validators/{validator_id}/blockInsights:
    get:
      tags:
        - Solana Performance
      summary: Get validator block insights
      description: >-
        This endpoint returns information about the composition of blocks
        produced by a validator. Use this endpoint to retrieve historical block
        insights for a specific validator.
      operationId: >-
        validator_block_insights_v1_solana_validators__validator_id__blockInsights_get
      parameters:
        - name: validator_id
          in: path
          required: true
          schema:
            type: string
            title: Validator Id
        - name: limit
          in: query
          required: false
          schema:
            type: integer
            description: The number of results returned per page
            default: 15
            title: Limit
          description: The number of results returned per page
        - name: offset
          in: query
          required: false
          schema:
            type: integer
            description: The number of results to skip before starting to return
            default: 0
            title: Offset
          description: The number of results to skip before starting to return
        - name: toDate
          in: query
          required: false
          schema:
            anyOf:
              - type: string
                format: date
              - type: 'null'
            description: End date
            examples:
              - '2023-12-31'
            title: Todate
          description: End date
        - name: fromDate
          in: query
          required: false
          schema:
            anyOf:
              - type: string
                format: date
              - type: 'null'
            description: Start date
            examples:
              - '2023-01-01'
            title: Fromdate
          description: Start date
        - name: toSlot
          in: query
          required: false
          schema:
            anyOf:
              - type: integer
                minimum: 0
              - type: 'null'
            description: End slot multiple of 3k
            title: Toslot
          description: End slot multiple of 3k
        - name: fromSlot
          in: query
          required: false
          schema:
            anyOf:
              - type: integer
                minimum: 0
              - type: 'null'
            description: Start slot multiple of 3k
            title: Fromslot
          description: Start slot multiple of 3k
        - name: from
          in: query
          required: false
          schema:
            anyOf:
              - {}
              - type: 'null'
            description: UTC day or slot multiple of 3k
            deprecated: true
            title: From
          description: UTC day or slot multiple of 3k
          deprecated: true
        - name: granularity
          in: query
          required: false
          schema:
            $ref: '#/components/schemas/networks__solana__granularity__Granularity'
            description: UTC day or 3k block interval
            default: day
          description: UTC day or 3k block interval
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/api__schemas__paginator__paginated_response_for_result_model___locals___PaginatedResponseWithResultModel__2
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Bad Request
      security:
        - HTTPBearer: []
components:
  schemas:
    networks__solana__granularity__Granularity:
      type: string
      enum:
        - 3k
        - day
      title: Granularity
    api__schemas__paginator__paginated_response_for_result_model___locals___PaginatedResponseWithResultModel__2:
      properties:
        previous:
          anyOf:
            - type: string
            - type: 'null'
          title: Previous
        next:
          anyOf:
            - type: string
            - type: 'null'
          title: Next
        pages:
          type: integer
          minimum: 0
          title: Pages
        results:
          items:
            properties:
              voteAccount:
                type: string
                title: Voteaccount
              from:
                title: From
              avgTransactions:
                anyOf:
                  - type: number
                  - type: string
                  - type: 'null'
                title: Avgtransactions
              avgComputeUnits:
                anyOf:
                  - type: number
                  - type: string
                  - type: 'null'
                title: Avgcomputeunits
              avgRewards:
                anyOf:
                  - type: number
                  - type: string
                  - type: 'null'
                title: Avgrewards
              avgMevRewards:
                anyOf:
                  - type: number
                  - type: string
                  - type: 'null'
                title: Avgmevrewards
              pctHighValueTransactions:
                anyOf:
                  - type: number
                  - type: string
                  - type: 'null'
                title: Pcthighvaluetransactions
              pctFailedTransactions:
                anyOf:
                  - type: number
                  - type: string
                  - type: 'null'
                title: Pctfailedtransactions
            type: object
            required:
              - voteAccount
              - from
              - avgTransactions
              - avgComputeUnits
              - avgRewards
              - avgMevRewards
              - pctHighValueTransactions
              - pctFailedTransactions
            title: SolanaValidatorBlocks
            examples:
              - avgComputeUnits: 25000.2
                avgMevRewards: 20.1
                avgRewards: 50.01
                avgTransactions: 250.1
                from_: '2024-12-14'
                percentageFailedTx: 0.2
                percentageHighValueTx: 0.1
                voteAccount: voteAccount
          type: array
          title: Results
      type: object
      required:
        - previous
        - next
        - pages
        - results
      title: PaginatedV1SolanaValidatorBlocks
      examples:
        - next: >-
            https://api.rated.network//v1/solana/validators/{validator_id}/blockInsights?limit=10&offset=30
          pages: 10
          previous: >-
            https://api.rated.network//v1/solana/validators/{validator_id}/blockInsights?limit=10&offset=10
          results:
            - - avgComputeUnits: 25000.2
                avgMevRewards: 20.1
                avgRewards: 50.01
                avgTransactions: 250.1
                from_: '2024-12-14'
                percentageFailedTx: 0.2
                percentageHighValueTx: 0.1
                voteAccount: voteAccount
    ErrorResponse:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/Error'
          type: array
          title: Detail
      type: object
      required:
        - detail
      title: ErrorResponse
    Error:
      properties:
        loc:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Loc
        msg:
          type: string
          title: Msg
        type:
          type: string
          title: Type
      type: object
      required:
        - msg
        - type
      title: Error
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````